<?php
/**
 * Class WC_Custom_Second_Order_Email file.
 *
 * @package WooCommerce\Emails 
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}
include('wp-content/plugins/woocommerce/includes/emails/class-wc-email.php');

if ( ! class_exists( 'WC_Custom_Second_Order_Email', false ) ) :

	class WC_Custom_Second_Order_Emailx extends WC_Email {
		public function __construct() {
			$this->id = 'custom_completed_order';
			$this->customer_email = true;
			$this->title = 'Custom Completed Order Email';
			$this->description = 'This is a custom completed order email sent via a different SMTP.';
			
			$this->template_html = 'emails/customer-completed-order.php';
			$this->template_plain = 'emails/plain/customer-completed-order.php';
			$this->placeholders   = array(
				'{order_date}'   => '',
				'{order_number}' => '',
			);
			
			/// Configurar el SMTP para esta instancia de correo
			$this->smtp_config(); // Configurar el SMTP

			// Triggers for this email.
			add_action( 'woocommerce_thankyou', array( $this, 'trigger' ), 10, 2 );
			
			parent::__construct();
		}
		
		// Configurar el SMTP para esta instancia de correo
		private function smtp_config() {
			$phpmailer = WC()->mailer(); // Obtener la instancia del mailer de WooCommerce
			// Configurar el transporte SMTP usando $phpmailer
			//$phpmailer->isSMTP();

			$phpmailer->SMTPAuth = true;

//			$phpmailer->Host = 'iredmail.winandoffice.com';
//			$phpmailer->Username = 'marketing@windowsandoffice.com';
//			$phpmailer->Password = 'Marketing.2021*';

//			$phpmailer->SMTPSecure = 'ssl';
//			$phpmailer->Port = 465;
			
			// Configurar el transporte SMTP
			/*$transport = ( new Swift_SmtpTransport( 'iredmail.winandoffice.com', 465 ) )
				->setUsername( 'marketing@windowsandoffice.com' )
				->setPassword( 'Marketing.2021*' )
				->setEncryption( 'ssl' );
			
			// Configurar el mailer con el nuevo transporte SMTP
			$mailer->setSwiftMailer( new Swift_Mailer( $transport ) );*/
			
		}

		/**
		 * Trigger the sending of this email.
		 *
		 * @param int            $order_id The order ID.
		 * @param WC_Order|false $order Order object.
		 */
		public function trigger( $order_id, $order = false ) {
			$this->setup_locale();

			$this->Host = 'iredmail.winandoffice.com';
			$this->Username = 'marketing@windowsandoffice.com';
			$this->Password = 'Marketing.2021*';
			$this->SMTPSecure = 'ssl';
			$this->Port = 465;

			if ( $order_id && ! is_a( $order, 'WC_Order' ) ) {
				$order = wc_get_order( $order_id );
			}

			if ( is_a( $order, 'WC_Order' ) ) {
				$this->object                         = $order;
				$this->recipient                      = $this->object->get_billing_email();
				$this->placeholders['{order_date}']   = wc_format_datetime( $this->object->get_date_created() );
				$this->placeholders['{order_number}'] = $this->object->get_order_number();
			}

			if ( $this->is_enabled() && $this->get_recipient() ) {
				$res=$this->send( $this->get_recipient(), $this->get_subject(), $this->get_content(), $this->get_headers(), $this->get_attachments() );
			}
	$depu['inicio']="inicio";
	$depu['subject']=$this->get_subject();
	$depu['content']=$this->get_content();
	$depu['headers']=$this->get_headers();
	$depu['attachments']=$this->get_attachments();
	update_option('_depu',$depu);
			$this->restore_locale();
			return $res?true:false; 
		}

		/**
		 * Get email subject.
		 *
		 * @since  3.1.0
		 * @return string
		 */
		public function get_default_subject() {
			return __( 'XXXX Your {site_title} order is now complete', 'woocommerce' );
		}

		/**
		 * Get email heading.
		 *
		 * @since  3.1.0
		 * @return string
		 */
		public function get_default_heading() {
			return __( 'Thanks for shopping with us', 'woocommerce' );
		}

		/**
		 * Get content html.
		 *
		 * @return string
		 */
		public function get_content_html() {
			return wc_get_template_html(
				$this->template_html,
				array(
					'order'              => $this->object,
					'email_heading'      => $this->get_heading(),
					'additional_content' => $this->get_additional_content(),
					'sent_to_admin'      => false,
					'plain_text'         => false,
					'email'              => $this,
				)
			);
		}

		/**
		 * Get content plain.
		 *
		 * @return string
		 */
		public function get_content_plain() {
			return wc_get_template_html(
				$this->template_plain,
				array(
					'order'              => $this->object,
					'email_heading'      => $this->get_heading(),
					'additional_content' => $this->get_additional_content(),
					'sent_to_admin'      => false,
					'plain_text'         => true,
					'email'              => $this,
				)
			);
		}

		/**
		 * Default content to show below main email content.
		 *
		 * @since 3.7.0
		 * @return string
		 */
		public function get_default_additional_content() {
			return __( 'Thanks for shopping with us.', 'woocommerce' );
		}

		
	}//fin de clase


endif;

return new WC_Custom_Second_Order_Emailx();
